<template>
  <ObModal
    ref="modal"
    :title="titleModal"
    size="md"
    class="approaching-offer-modal"
    data-qa="approachingOfferModal"
  >
    <ObForm
      :form-model="formModel"
      :form-data="formData"
      ok-text="Отправить предложение"
      :is-loading="isLoading"
      data-qa="approachingOfferForm"
      @submit="onSubmitHandler"
    >
      <div class="order-approaching-offer">
        <div class="title">Кому отправить</div>
        <div class="user-item">
          <i class="icon role-client" />
          <span>{{ dataSource.carrierTitle }}</span>
        </div>
        <div class="title">Предложение “туда”</div>
        <div class="route">
          <Route
            :route-data="dataSource.targetSuborder"
          />
        </div>
        <template v-if="dataSource.fromSuborder">
          <div class="title">Закольцовка “обратно”</div>
          <div class="route">
            <Route
              :route-data="dataSource.fromSuborder"
            />
          </div>
        </template>
        <template v-if="dataSource.resources">
          <div class="title">Запрос на ресурс</div>
          <div class="resources row">
            <div
              v-for="({ superclass, uuid }, index) in dataSource.resources"
              :key="uuid"
              class="col-xs-6 resources__item"
            >
              <OrderResourceSelect
                :order-uuid="dataSource.targetSuborderUuid"
                :is-disabled="true"
                :value="dataSource.resources[index]"
                :resource-superclass="superclass"
              />
            </div>
          </div>
        </template>
        <div class="title">Итого</div>
        <div class="row">
          <div class="col-xs-6">
            <ObInput
              v-model="formData.offerPrice"
              label="Предложение перевозчику"
              :subTitle="'₽'"
              placeholder="Введите значение"
              type="money:2"
              property="offerPrice"
            />
          </div>
          <div class="col-xs-6">
            <ObInput
              v-model="dataSource.totalPriceWithoutVat"
              label="Суммарно индикатив (без учета НДС)"
              :subTitle="'₽'"
              :readonly="true"
              type="money:2"
            />
          </div>
        </div>
      </div>
    </ObForm>
  </ObModal>
</template>

<script>
import ObModal from 'common-components/src/obComponents/obModal'
import ObForm from 'common-components/src/obComponents/obForm'
import ObInput from 'common-components/src/obComponents/obInput'
import Route from '../orderItem/execution/RouteSimple'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import OrderResourceSelect from "@/components/Order/resourceSelectors/orderResourceSelect"
import { required } from "vuelidate/lib/validators"
import { formatNumber } from "common-components/src/helpers/common"
import api from '@/api'

export default {
  name: 'ApproachingOfferModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObModal,
    Route,
    ObForm,
    ObInput,
    OrderResourceSelect
  },
  data () {
    return {
      isLoading: false,
    }
  },
  computed: {
    formModel () {
      const { minOfferPrice, maxOfferPrice } = this.dataSource
      const isCorrectPrice = (value, vm) => {
        return Boolean(vm && value && value >= minOfferPrice && value <= maxOfferPrice)
      }
      return {
        toSuborderUuid: {
          value: null,
        },
        fromSuborderUuid: {
          value: null,
        },
        targetSuborderUuid: {
          value: null,
        },
        carrierUuid: {
          value: null,
        },
        offerPrice: {
          value: null,
          validator: {
            required,
            isCorrectPrice: {
              method: isCorrectPrice,
              error: `Введите значение от ${formatNumber(minOfferPrice / 100)} до ${formatNumber(maxOfferPrice / 100)} ₽`
            }
          }
        }
      }
    },
    isNew () {
      return !this.dataSource?.offerUuid
    },
    titleModal () {
      return this.isNew ? 'Отправить целевое предложение' : 'Целевое предложение'
    }
  },
  methods: {
    open () {
      this.$refs.modal.open()
    },
    close () {
      this.$refs.modal.close()
    },
    async onSubmitHandler () {
      try {
        await api.orderProcess.createOffer({ data: this.formData })
        this.close()
        this.$emit('submitted')
        this.$notification({
          type: 'system_notification_success',
          message: `Предложение было успешно отправлено`
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Не удалось отправить предложение`
        })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-approaching-offer {
    padding-bottom: 20px;
    .row {
      margin-top: 0!important;
      margin-bottom: 0!important;
      margin-left: -0.5rem;
      margin-right: -0.5rem;
      & > [class^="col-"] {
        padding-left: 0.5rem;
        padding-right: 0.5rem;
      }
    }
    .resources {
      &__item {
        margin-bottom: 10px;
      }
    }
    .title {
      margin-top: 30px;
      margin-bottom: 10px;
      @include font-mixin(16px, 20px, 600, $color-text-base);
    }
    .user-item {
      display: inline-flex;
      align-items: center;
      padding: 5px 9px;
      background-color: $blue-250;
      border-radius: 10px;
      .icon {
        margin-right: 4px;
        font-size: 16px;
        color: $blue-700;
      }
      span {
        @include font-mixin(14px, 18px, 400, $color-text-base);
      }
    }
    .route {

    }
  }
</style>
